"use strict";
// Copyright (c) Jeremy Tuloup
// Distributed under the terms of the Modified BSD License.
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const base_1 = require("@jupyter-widgets/base");
const React = __importStar(require("react"));
const jupyterlab_system_monitor_base_1 = require("jupyterlab-system-monitor-base");
require("jupyterlab-system-monitor-base/style/index.css");
const version_1 = require("./version");
const react_dom_1 = __importDefault(require("react-dom"));
class KernelMemoryUsageModel extends base_1.DOMWidgetModel {
    defaults() {
        return Object.assign({}, super.defaults(), { _model_name: KernelMemoryUsageModel.model_name, _model_module: KernelMemoryUsageModel.model_module, _model_module_version: KernelMemoryUsageModel.model_module_version, _view_name: KernelMemoryUsageModel.view_name, _view_module: KernelMemoryUsageModel.view_module, _view_module_version: KernelMemoryUsageModel.view_module_version, _current: 0, limit: 0, label: "Mem:", _percentage: null, _values: [] });
    }
}
KernelMemoryUsageModel.serializers = Object.assign({}, base_1.DOMWidgetModel.serializers);
KernelMemoryUsageModel.model_name = "KernelMemoryUsageModel";
KernelMemoryUsageModel.model_module = version_1.MODULE_NAME;
KernelMemoryUsageModel.model_module_version = version_1.MODULE_VERSION;
KernelMemoryUsageModel.view_name = "KernelMemoryUsageView"; // Set to null if no view
KernelMemoryUsageModel.view_module = version_1.MODULE_NAME; // Set to null if no view
KernelMemoryUsageModel.view_module_version = version_1.MODULE_VERSION;
exports.KernelMemoryUsageModel = KernelMemoryUsageModel;
class MemoryComponent extends React.Component {
    constructor(props) {
        super(props);
        this.componentDidMount = () => {
            this.setupListeners();
        };
        this.componentWillUnmount = () => {
            this.removeListeners();
        };
        this.setupListeners = () => {
            const { model } = this.props;
            model.on('change', () => {
                this.setState({
                    label: model.get('label'),
                    text: model.get('_text'),
                    values: model.get('_values'),
                    percentage: model.get('_percentage'),
                });
            });
        };
        this.removeListeners = () => {
            const { model } = this.props;
            model.off();
        };
        this.state = {
            label: "",
            text: "",
            values: [],
            percentage: null
        };
    }
    render() {
        return (React.createElement(jupyterlab_system_monitor_base_1.MemoryUsageComponent, Object.assign({ style: { height: "40px" } }, this.state)));
    }
}
class KernelMemoryUsageView extends base_1.DOMWidgetView {
    initialize() {
        const element = React.createElement(MemoryComponent, { model: this.model });
        react_dom_1.default.render(element, this.el);
    }
}
exports.KernelMemoryUsageView = KernelMemoryUsageView;
//# sourceMappingURL=widget.js.map